<!DOCTYPE html>

<html lang="en" data-content_root="../../">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>helpers.helper_functions &#8212; NLP004  documentation</title>
    <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=4f649999" />
    <link rel="stylesheet" type="text/css" href="../../_static/alabaster.css?v=039e1c02" />
    <script src="../../_static/documentation_options.js?v=5929fcd5"></script>
    <script src="../../_static/doctools.js?v=888ff710"></script>
    <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
   
  <link rel="stylesheet" href="../../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <h1>Source code for helpers.helper_functions</h1><div class="highlight"><pre>
<span></span><span class="kn">import</span> <span class="nn">os</span>

<span class="kn">import</span> <span class="nn">pymysql</span>
<span class="kn">from</span> <span class="nn">dotenv</span> <span class="kn">import</span> <span class="n">load_dotenv</span>

<span class="kn">import</span> <span class="nn">requests</span>

<div class="viewcode-block" id="filepath_to_doi">
<a class="viewcode-back" href="../../helpers/helper_functions.html#helpers.helper_functions.filepath_to_doi">[docs]</a>
<span class="k">def</span> <span class="nf">filepath_to_doi</span><span class="p">(</span><span class="n">file_path</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&#39;&#39;&#39;</span>
<span class="sd">    Converst file_path to DOI.</span>

<span class="sd">    Arguments:</span>
<span class="sd">        </span>
<span class="sd">        file_path (str): File path.</span>

<span class="sd">    Returns:</span>

<span class="sd">        str: DOI, extracted from the file name.</span>
<span class="sd">    &#39;&#39;&#39;</span>
    <span class="k">return</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">splitext</span><span class="p">(</span><span class="n">file_path</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s1">&#39;/&#39;</span><span class="p">)[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s1">&#39;_&#39;</span><span class="p">,</span> <span class="s1">&#39;/&#39;</span><span class="p">)</span></div>


<div class="viewcode-block" id="doi_to_filename">
<a class="viewcode-back" href="../../helpers/helper_functions.html#helpers.helper_functions.doi_to_filename">[docs]</a>
<span class="k">def</span> <span class="nf">doi_to_filename</span><span class="p">(</span><span class="n">doi</span><span class="p">,</span> <span class="n">ext</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&#39;&#39;&#39;</span>
<span class="sd">    Converst DOI to file name.</span>

<span class="sd">    Arguments:</span>

<span class="sd">        doi (str): DOI to be converted.</span>
<span class="sd">        ext (str): Extension of the file. Defaults to None.</span>
<span class="sd">    </span>
<span class="sd">    Returns:</span>

<span class="sd">        str: result file name.</span>
<span class="sd">    &#39;&#39;&#39;</span>
    <span class="k">if</span> <span class="n">doi</span><span class="o">.</span><span class="n">startswith</span><span class="p">(</span><span class="s2">&quot;doi:&quot;</span><span class="p">):</span>
        <span class="n">doi</span> <span class="o">=</span> <span class="n">doi</span><span class="p">[</span><span class="mi">4</span><span class="p">:]</span>
    <span class="n">doi</span> <span class="o">=</span> <span class="n">doi</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s2">&quot;/&quot;</span><span class="p">,</span> <span class="s2">&quot;_&quot;</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">ext</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">doi</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">ext</span><span class="p">,</span> <span class="n">doi</span> <span class="o">+</span> <span class="s2">&quot;.&quot;</span> <span class="o">+</span> <span class="n">ext</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">doi</span></div>


<div class="viewcode-block" id="connect_to_db">
<a class="viewcode-back" href="../../helpers/helper_functions.html#helpers.helper_functions.connect_to_db">[docs]</a>
<span class="k">def</span> <span class="nf">connect_to_db</span><span class="p">():</span>
<span class="w">    </span><span class="sd">&#39;&#39;&#39;</span>
<span class="sd">    Connects to the MySQL/MariaDB database. Uses pymysql.</span>

<span class="sd">    Arguments:</span>

<span class="sd">        none</span>
<span class="sd">    </span>
<span class="sd">    Returns:</span>

<span class="sd">        pymysql.cursors.Cursor: Cursor to the database connection        </span>
<span class="sd">    &#39;&#39;&#39;</span>
    <span class="n">load_dotenv</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">dirname</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">dirname</span><span class="p">(</span><span class="vm">__file__</span><span class="p">)),</span> <span class="s1">&#39;.env&#39;</span><span class="p">))</span>

    <span class="n">db_params</span> <span class="o">=</span> <span class="p">{</span>
        <span class="s1">&#39;host&#39;</span><span class="p">:</span>  <span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;db_host&#39;</span><span class="p">),</span>
        <span class="s1">&#39;user&#39;</span><span class="p">:</span>  <span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;db_user&#39;</span><span class="p">),</span>
        <span class="s1">&#39;password&#39;</span><span class="p">:</span>  <span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;db_pass&#39;</span><span class="p">),</span>
        <span class="s1">&#39;database&#39;</span><span class="p">:</span>  <span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;db_name&#39;</span><span class="p">),</span>
    <span class="p">}</span>

    <span class="n">db_conn</span> <span class="o">=</span> <span class="n">pymysql</span><span class="o">.</span><span class="n">connect</span><span class="p">(</span><span class="o">**</span><span class="n">db_params</span><span class="p">)</span>

    <span class="k">return</span> <span class="n">db_conn</span></div>


<div class="viewcode-block" id="filter_named_entities">
<a class="viewcode-back" href="../../helpers/helper_functions.html#helpers.helper_functions.filter_named_entities">[docs]</a>
<span class="k">def</span> <span class="nf">filter_named_entities</span><span class="p">(</span><span class="n">named_entities</span><span class="p">,</span> <span class="nb">filter</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&#39;&#39;&#39;</span>
<span class="sd">    Filters list of named entity dictionaries based on match of entity group (LOC, PER, ORG) to given filter.</span>

<span class="sd">    Arguments:</span>

<span class="sd">        named_entities (list): List of named entities, each beaing a dictionary.</span>
<span class="sd">        filter: group of named entities, which has to be filtered.</span>
<span class="sd">    </span>
<span class="sd">    Returns:</span>

<span class="sd">        list: List of words, entity group of which match the filter.</span>
<span class="sd">    &#39;&#39;&#39;</span>
    <span class="n">filtered</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">for</span> <span class="n">entity</span> <span class="ow">in</span> <span class="n">named_entities</span><span class="p">:</span>
        <span class="k">if</span> <span class="p">(</span><span class="n">entity</span><span class="p">[</span><span class="s1">&#39;entity_group&#39;</span><span class="p">]</span> <span class="o">==</span> <span class="nb">filter</span> <span class="ow">and</span> <span class="n">entity</span><span class="p">[</span><span class="s1">&#39;word&#39;</span><span class="p">]</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">filtered</span><span class="p">):</span>
            <span class="n">filtered</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">entity</span><span class="p">[</span><span class="s1">&#39;word&#39;</span><span class="p">])</span>
    <span class="k">return</span> <span class="n">filtered</span></div>


<div class="viewcode-block" id="crossref_metada_api_call">
<a class="viewcode-back" href="../../helpers/helper_functions.html#helpers.helper_functions.crossref_metada_api_call">[docs]</a>
<span class="k">def</span> <span class="nf">crossref_metada_api_call</span><span class="p">(</span><span class="n">doi</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&#39;&#39;&#39;</span>
<span class="sd">    Gets metadata for given DOI from CrossRef.</span>

<span class="sd">    Arguments:</span>

<span class="sd">        doi (str): DOI, for which metadata is needed.</span>
<span class="sd">    </span>
<span class="sd">    Returns:</span>

<span class="sd">        http response: response from CrossRef.</span>
<span class="sd">    &#39;&#39;&#39;</span>
    <span class="k">return</span> <span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;https://api.crossref.org/works/&#39;</span><span class="o">+</span><span class="n">doi</span><span class="p">)</span></div>

</pre></div>

          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../../index.html">NLP004</a></h1>








<h3>Navigation</h3>
<p class="caption" role="heading"><span class="caption-text">Contents:</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../modules.html">python</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../pipe.html">pipe</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../../index.html">Documentation overview</a><ul>
  <li><a href="../index.html">Module code</a><ul>
  </ul></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>document.getElementById('searchbox').style.display = "block"</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2023, Ughur Mammadzada.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 7.2.6</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.13</a>
      
    </div>

    

    
  </body>
</html>